/**
   The MyPrintBuffered class demonstrates how
   a buffered library function might work.

   The MyPrintBuffered class has a static array that is the buffer.

   The myPrint() method appends its string to the buffer. When
   the buffer is "full" (has length > 10) the buffer is printed
   and then the buffer is "cleared".

   The myFlush() method can be used to force the buffer's contents to be printed.
*/
public class MyPrintBuffered
{
   private static String buffer = "";

   /**
      Simulate a buffer of size 10 characters.
   */
   public static void myPrint(String str)
   {
      buffer += str;
      if (buffer.length() > 10)
      {
         System.out.print( buffer );
         buffer = "";
      }
   }

   public static void myFlush()
   {
      System.out.print(buffer);
      buffer = "";
   }


   public static void main(String[] args)
   {
      myPrint("Hello");
      myPrint(" there.\n");
      myPrint("How are you ");
      myPrint("doing?\n");
      //myFlush();
/*
      final long startTime = System.currentTimeMillis();
      for (int i = 0; i < 300_000; ++i)
      {
         myPrint("a");
      }
      final long stopTime = System.currentTimeMillis();
      System.out.println("\nWall-clock time: " + (stopTime - startTime));
*/
   }
}
